import jsdai.SMachining_schema.AProject;
import jsdai.SMachining_schema.EProject;
import jsdai.lang.ASdaiModel;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;
import jsdai.lang.SdaiModel;


public class DadosProjeto {
	
	public DadosProjeto(){
	}
	
	public static String getProjectName() throws SdaiException
	{
		String projectName = null;
		SdaiModel model = LerArquivoSTEPexemplo.model; 
		ASdaiModel models = LerArquivoSTEPexemplo.repository.getModels();
		SdaiIterator modelIterator = models.createIterator();

		while (modelIterator.next()) {

			model = models.getCurrentMember(modelIterator);
			if (model.getMode() == SdaiModel.NO_ACCESS) {
				model.startReadOnlyAccess();
			}
			AProject projects = (AProject) model.getInstances(EProject.class);

			SdaiIterator projectIterator = projects.createIterator();
			while (projectIterator.next()) {
				EProject project = projects.getCurrentMember(projectIterator);
				System.out.println("Project instance No.: "
						+ project.getPersistentLabel());
				System.out.println("Project ID: " + project.getIts_id(null));
				projectName = project.getIts_id(null);

			}
		}
		return projectName;
		
	}
}
