package br.UFSC.GRIMA.Entity;

import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.APlane;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.EMachining_workingstep;
import jsdai.SMachining_schema.EPlane;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class PlaneReader {
	APlane aPlane;
	AAxis2_placement_3d aAxis2Placement_3d;
	
	public PlaneReader(APlane aPlane) {
		this.aPlane =aPlane;
	}

	public AAxis2_placement_3d getAAxis2_Placement_3d() {
		aAxis2Placement_3d = new AAxis2_placement_3d();
		EPlane ePlane;
		try {
			SdaiIterator iterator = aPlane.createIterator();
			int i = 1;
			while (iterator.next()) {
				
				ePlane = (EPlane) aPlane
						.getCurrentMember(iterator);
				
				
				aAxis2Placement_3d.addByIndex(i, (EAxis2_placement_3d) ePlane.getPosition(null));
				i++;
			}

		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return aAxis2Placement_3d;
	}

}
