package br.UFSC.GRIMA.entidades;

import jsdai.lang.SdaiException;

public class ProjectManager {

	static STEPHoleProject project;

	public static STEPHoleProject getHoleProject() throws SdaiException {

		if (project == null) {
			project = new STEPHoleProject();
		}

		return project;
	}

	public static STEPHoleProject resetProject() throws SdaiException {

		project = new STEPHoleProject();

		return project;
	}

	public static void setMaterialType(int selectedIndex) throws SdaiException{
		if(project==null){
			project = new STEPHoleProject();
		}
		Material material =project.getMaterialModel();
		switch (selectedIndex) {
		case 0:
			material.setName("SAE1015");
			material.setType("Steel");
			material.setPropertie("315Mpa");
			break;
		case 1:
			material.setName("SAE1020");
			material.setType("Steel");
			material.setPropertie("330Mpa");
			break;
		case 2:
			material.setName("SAE1030");
			material.setType("Steel");
			material.setPropertie("345Mpa");
			break;
		default:
			break;
		}
	}
	
	public static void setToolType(int selectedIndex) throws SdaiException {

		if(project==null){
			project = new STEPHoleProject();
		}
		
		switch (selectedIndex) {
		case 0:
			project.setHoleRay(5);
			project.setHoleId("Hole 10mm");
			project.setToolId("Drill 10mm");
			break;
		case 1:
			project.setHoleRay(6.75);
			project.setHoleId("Hole 13.5mm");
			project.setToolId("Drill 13.5mm");
			break;
		case 2:
			project.setHoleRay(7.5);
			project.setHoleId("Hole 15mm");
			project.setToolId("Drill 15mm");
			break;
		default:
			break;
		}
	}

}
