package br.UFSC.GRIMA.Entity;

import jsdai.SMachining_schema.AAxis2_placement_3d;
import jsdai.SMachining_schema.ACartesian_point;
import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.ECartesian_point;
import jsdai.lang.SdaiException;
import jsdai.lang.SdaiIterator;

public class Axis2Placement_3dReader {
	AAxis2_placement_3d aAxis2Placement_3d;

	public Axis2Placement_3dReader(AAxis2_placement_3d aAxis2Placement_3d) {
		this.aAxis2Placement_3d = aAxis2Placement_3d;
	}
	
	public Axis2Placement_3dReader(EAxis2_placement_3d eAxis2Placement_3d) {
		aAxis2Placement_3d = new AAxis2_placement_3d();
		try {
			aAxis2Placement_3d.addByIndex(1, eAxis2Placement_3d);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
	}

	public ACartesian_point getCartesianPoint() {
		ACartesian_point aCartesianPoint = new ACartesian_point();

		try {
			SdaiIterator iterator = aAxis2Placement_3d.createIterator();
			int i = 1;
			while (iterator.next()) {

				EAxis2_placement_3d eAxis2Placement_3d = (EAxis2_placement_3d) aAxis2Placement_3d.getCurrentMember(iterator);
				
				aCartesianPoint.addByIndex(i, (ECartesian_point) eAxis2Placement_3d.getLocation(null));
				i++;
			}

		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return aCartesianPoint;

	}
	
	public ECartesian_point getECartesianPoint() {
		ECartesian_point cartesianPoint = null;
		try {
			cartesianPoint =   getCartesianPoint().getByIndex(1);
		} catch (SdaiException e) {
			e.printStackTrace();
		}
		return cartesianPoint;
	}
}
