package br.UFSC.GRIMA.Entity;

import jsdai.SMachining_schema.EAxis2_placement_3d;
import jsdai.SMachining_schema.EBlock;
import jsdai.lang.SdaiException;

public class BlockReader {

	EBlock eBlock;
	String blockName;
	EAxis2_placement_3d blockPosition;
	double X;
	double Y;
	double Z;

	public BlockReader(EBlock block) {
		eBlock = block;
	}

	public String getName() throws SdaiException {
		blockName = eBlock.getName(null);
		return blockName;
	}

	public EAxis2_placement_3d getPosition() throws SdaiException {
		blockPosition = eBlock.getPosition(null);
		return blockPosition;
	}

	public double getX() throws SdaiException {
		X = eBlock.getX(null);
		return X;
	}

	public double getY() throws SdaiException {
		Y = eBlock.getY(null);
		return Y;
	}

	public double getZ() throws SdaiException {
		Z = eBlock.getZ(null);
		return Z;
	}

}
